---
title: VRLayerInit
slug: Web/API/VRLayerInit
tags:
  - API
  - Dictionary
  - Experimental
  - Interface
  - Reference
  - VR
  - VRLayerInit
  - Virtual Reality
  - WebVR
---
<div>{{APIRef("WebVR API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>VRLayerInit</code></strong> interface (dictionary) of the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> represents a content layer (an {{domxref("HTMLCanvasElement")}} or {{domxref("OffscreenCanvas")}}) that you want to present in a VR display.</p>

<p>You can retrieve <code>VRLayerInit</code> objects using {{domxref("VRDisplay.getLayers()")}}, and present them using the {{domxref("VRDisplay.requestPresent()")}} method.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("VRLayerInit.leftBounds")}}</dt>
 <dd>Defines the left texture bounds of the canvas whose contents will be presented by the {{domxref("VRDisplay")}}.</dd>
 <dt>{{domxref("VRLayerInit.rightBounds")}}</dt>
 <dd>Defines the right texture bounds of the canvas whose contents will be presented by the {{domxref("VRDisplay")}}.</dd>
 <dt>{{domxref("VRLayerInit.source")}}</dt>
 <dd>Defines the canvas whose contents will be presented by the {{domxref("VRDisplay")}} when {{domxref("VRDisplay.submitFrame()")}} is called.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">// currently returns an empty array
var layers = vrDisplay.getLayers();

if(navigator.getVRDisplays) {
  console.log('WebVR 1.1 supported');
  // Then get the displays attached to the computer
  navigator.getVRDisplays().then(function(displays) {
    // If a display is available, use it to present the scene
    if(displays.length &gt; 0) {
      vrDisplay = displays[0];
      console.log('Display found');
      // Starting the presentation when the button is clicked: It can only be called in response to a user gesture
      btn.addEventListener('click', function() {
        vrDisplay.requestPresent([{ source: canvas }]).then(function() {
          console.log('Presenting to WebVR display');

          // Here it returns an array of VRLayerInit objects
          var layers = vrDisplay.getLayers();

          ...
        });
      });
    }
  });
}</pre>

<p>{{domxref("VRLayerInit")}} objects look something like this:</p>

<pre class="brush: js">{
  leftBounds : [ ... ],
  rightBounds: [ ... ],
  source: <em>canvasReference</em>
}</pre>

<div class="note">
<p><strong>Note</strong>: The <code>canvasReference</code> refers to the {{htmlelement("canvas")}} element itself, not the WebGL context associated with the canvas. The other two members are arrays</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebVR 1.1', '#interface-vrlayerinit', 'VRLayerInit')}}</td>
   <td>{{Spec2('WebVR 1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VRLayerInit")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a></li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
